Transcript show: 'ASN1Constants'; cr!
Smalltalk at: #ASN1Constants put: Dictionary new!
ASN1Constants at: #classApplication put:  64!
ASN1Constants at: #classContextSpecific put:  128!
ASN1Constants at: #classPrivate put:  192!
ASN1Constants at: #classUniversal put:  0!
ASN1Constants at: #idBitString put:  3!
ASN1Constants at: #idBoolean put:  1!
ASN1Constants at: #idIA5String put:  22!
ASN1Constants at: #idInteger put:  2!
ASN1Constants at: #idNull put:  5!
ASN1Constants at: #idObjectIdentifier put:  6!
ASN1Constants at: #idOctetString put:  4!
ASN1Constants at: #idPrintableString put:  19!
ASN1Constants at: #idSequence put:  16!
ASN1Constants at: #idSet put:  17!
ASN1Constants at: #idUTCTime put:  23!
ASN1Constants at: #maskClass put:  192!
ASN1Constants at: #maskConstructed put:  32!
ASN1Constants at: #maskTag put:  31!
ASN1Constants at: #tagHigh put:  31!

Transcript show: 'ASN1ObjectIdentifiers'; cr!
Smalltalk at: #ASN1ObjectIdentifiers put: Dictionary new!
ASN1ObjectIdentifiers at: #x1x2x840x10040x4x1 put:  ('id-dsa')!
ASN1ObjectIdentifiers at: #x1x2x840x10040x4x3 put:  ('id-dsa-with-sha1')!
ASN1ObjectIdentifiers at: #x1x2x840x113533x7x65x0 put:  ('entrustVersion')!
ASN1ObjectIdentifiers at: #x1x2x840x113549x1x1x1 put:  ('rsaEncryption')!
ASN1ObjectIdentifiers at: #x1x2x840x113549x1x1x2 put:  ('md2WithRSAEncryption')!
ASN1ObjectIdentifiers at: #x1x2x840x113549x1x1x4 put:  ('md5WithRSAEncryption')!
ASN1ObjectIdentifiers at: #x1x2x840x113549x1x1x5 put:  ('sha-1WithRSAEncryption')!
ASN1ObjectIdentifiers at: #x1x2x840x113549x1x9x1 put:  ('e-mailAddress')!
ASN1ObjectIdentifiers at: #x1x3x14x3x2x12 put:  ('dsa')!
ASN1ObjectIdentifiers at: #x1x3x14x3x2x27 put:  ('dsa With SHA1')!
ASN1ObjectIdentifiers at: #x2x16x840x1x113730x1x1 put:  ('netscapeCertificateType')!
ASN1ObjectIdentifiers at: #x2x16x840x1x113730x1x12 put:  ('SslServerName')!
ASN1ObjectIdentifiers at: #x2x16x840x1x113730x1x13 put:  ('netscapeCertificateComment')!
ASN1ObjectIdentifiers at: #x2x16x840x1x113730x1x2 put:  ('BaseURL')!
ASN1ObjectIdentifiers at: #x2x16x840x1x113730x1x3 put:  ('RevocationURL')!
ASN1ObjectIdentifiers at: #x2x16x840x1x113730x1x4 put:  ('CARevocationURL')!
ASN1ObjectIdentifiers at: #x2x16x840x1x113730x1x7 put:  ('renewalURL')!
ASN1ObjectIdentifiers at: #x2x16x840x1x113730x1x8 put:  ('netscapeCaPolicyURL')!
ASN1ObjectIdentifiers at: #x2x5x29x14 put:  ('subjectKeyIdentifier')!
ASN1ObjectIdentifiers at: #x2x5x29x15 put:  ('keyUsage')!
ASN1ObjectIdentifiers at: #x2x5x29x16 put:  ('privateKeyUsagePeriod')!
ASN1ObjectIdentifiers at: #x2x5x29x17 put:  ('subjectAlternativeName')!
ASN1ObjectIdentifiers at: #x2x5x29x18 put:  ('issuerAlternativeName')!
ASN1ObjectIdentifiers at: #x2x5x29x19 put:  ('basicConstraints')!
ASN1ObjectIdentifiers at: #x2x5x29x20 put:  ('cRLNumber')!
ASN1ObjectIdentifiers at: #x2x5x29x21 put:  ('reasonCode')!
ASN1ObjectIdentifiers at: #x2x5x29x23 put:  ('holdInstructionCode')!
ASN1ObjectIdentifiers at: #x2x5x29x24 put:  ('invalidityDate')!
ASN1ObjectIdentifiers at: #x2x5x29x27 put:  ('deltaCRLIndicator')!
ASN1ObjectIdentifiers at: #x2x5x29x28 put:  ('issuingDistributionPoint')!
ASN1ObjectIdentifiers at: #x2x5x29x29 put:  ('certificateIssuer')!
ASN1ObjectIdentifiers at: #x2x5x29x3 put:  ('certificate policies - old')!
ASN1ObjectIdentifiers at: #x2x5x29x30 put:  ('nameConstraints')!
ASN1ObjectIdentifiers at: #x2x5x29x31 put:  ('cRLDistributionPoints')!
ASN1ObjectIdentifiers at: #x2x5x29x32 put:  ('certificatePolicies')!
ASN1ObjectIdentifiers at: #x2x5x29x33 put:  ('policyMappings')!
ASN1ObjectIdentifiers at: #x2x5x29x35 put:  ('authorityKeyIdentifier')!
ASN1ObjectIdentifiers at: #x2x5x29x36 put:  ('policyConstraints')!
ASN1ObjectIdentifiers at: #x2x5x4x10 put:  ('O')!
ASN1ObjectIdentifiers at: #x2x5x4x11 put:  ('OU')!
ASN1ObjectIdentifiers at: #x2x5x4x13 put:  ('??')!
ASN1ObjectIdentifiers at: #x2x5x4x3 put:  ('CN')!
ASN1ObjectIdentifiers at: #x2x5x4x6 put:  ('C')!
ASN1ObjectIdentifiers at: #x2x5x4x7 put:  ('L')!
ASN1ObjectIdentifiers at: #x2x5x4x8 put:  ('S')!
ASN1ObjectIdentifiers at: #x2x5x8x1x1 put:  ('rsa')!

Object subclass: #ASN1Value
	instanceVariableNames: 'class constructed tag length data totalBytes '
	classVariableNames: ''
	poolDictionaries: 'ASN1Constants '
	category: 'X509'!
!ASN1Value commentStamp: '<historical>' prior: 0!
An ASN.1 value!


!ASN1Value methodsFor: 'private - parsing' stamp: 'PT 1/7/1999 12:56'!
decodeHighTagNumber: array startingAt: pos
	"Answers a tag number encoded in high-tag format"

	| i h b |
	tag := 0.
	i := pos.
	h := true.
	[ h ] whileTrue: [
		b := array at: i.
		i := i + 1.
		(b bitAnd: 16r80) = 16r80
			ifFalse: [tag := (tag bitShift: 7) + b. h := false]
			ifTrue: [tag := ((tag bitShift: 7) + (b bitAnd: 16r7F))]
	].
	^i - pos! !

!ASN1Value methodsFor: 'private - parsing' stamp: 'PT 1/9/1999 18:22'!
parse: array startingAt: pos
	"Extracts the components of an ASN.1 Value from the specified byte array"

	| b p tl |
	b := array at: pos.
	class := b bitAnd: maskClass.
	constructed := (b bitAnd: maskConstructed) = maskConstructed.
	tl := 1.
	tag := (array at: pos) bitAnd: maskTag.
	tag = tagHigh
		ifTrue: [tl := self decodeHighTagNumber: array startingAt: pos + 1].
	p := pos + tl.
	b := array at: p.
	(b bitAnd: 16r80) = 0
		ifTrue: [length := b
		]
		ifFalse: [
			length := 0.
			(b bitAnd: 16r7F) timesRepeat: [
				p := p + 1.
				length := (length bitShift: 8) bitOr: (array at: p)
			]
		].
	length = 0
		ifTrue: [length := ((array size) - p) negated].
	p := p + 1.
	totalBytes := p - pos + (length abs).
	data := array copyFrom: p to: p + (length abs) - 1.
	^self! !


!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:25'!
data
	"Answers the byte array containing this ASN1Value's data"

	^data! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/14/1999 09:34'!
getBitStringAsFormattedHexStrings
	"Answers an array of  Strings representing the bit string represented by this ASN1Value's data but only if the tag is a kind of bit string. NOTE: This suffices for working with certificates since the number of bits involved is always a multiple of 8. For a generic bit string of any length, the  'number of unused bits' (first byte of data) would have to be taken into consideration"

	| hc hcs hs oc ix |
	tag = idBitString ifFalse: [^nil].
	oc := OrderedCollection new.
	hs := ''.
	ix := 1.
	2 to: (data size) do: [:b | hcs := (data at: b) radix: 16 asString.
		hc := hcs copyFrom: 6 to: hcs size.
		(hc size = 1)
			ifTrue: [hc := '0', hc].
		hs := hs, hc.
		(b = data size)
			ifFalse: [hs := hs, ':'].
		((ix \\ 16) = 0)
			ifTrue: [
				oc addLast: hs.
				hs := ''.
			].
		ix := ix + 1.
	].
	^oc! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:27'!
getClass
	"Answers this ASN1Value's class. The class is one of universal, application, context-specific or private. It is NOT the Smalltalk class"

	^class! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:28'!
getInteger
	"Answers the integer value represented by this ASN1Value's data but only if the tag is INTEGER"

	| val |
	tag = idInteger
		ifFalse: [^nil].
	val := 0.
	data do: [:i | val := (val bitShift: 8) + i].
	^val! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/10/1999 22:04'!
getOID
	"Answers the object identifier but only if tag is OID"

	| b len oid |
	tag = idObjectIdentifier
		ifFalse: [^nil].
	b := data at: 1.
	oid := ((b // 40) asString) , '.'  ,((b rem:40) asString).
	len := 0.
	2 to: length do: [:i | 
		b := data at: i.
		((b bitAnd: 16r80) = 16r80) 
		ifTrue: [len := ((len bitShift: 7) + (b bitAnd: 16r7F))]
		ifFalse: [len := (len bitShift: 7) + b.oid := oid , '.', (len asString).len := 0]
	].
	^oid! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:30'!
getOIDDescription
	"Answers the object identifier description but only if tag is OID"

	| oid ix |
	tag = idObjectIdentifier
		ifFalse: [^nil].
	oid := 'x', self getOID.
	ix := 1.
	[ix < oid size]
		whileTrue: [
			((oid at: ix) = $.)
				ifTrue: [oid at: ix put: $x].
			ix := ix + 1.
		].
	(ASN1ObjectIdentifiers includesKey: oid asSymbol)
		ifTrue: [^ASN1ObjectIdentifiers at: oid asSymbol]
		ifFalse: [^self getOID]! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:30'!
getString
	"Answers the string represented by this ASN1Value's data but only if the tag is a kind of string"

	^data asString! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:30'!
length
	"Answers the length of this ASN1Value's data"

	^length abs! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:30'!
tag
	"Answers this ASN1Value's tag"

	^tag! !

!ASN1Value methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:33'!
totalBytes
	"Answers the total size in bytes of this ASN1Value"
	"NOTE: this is the number of bytes occupied by the DER encoded representation of the value"
	"       This value is used to facilitate parsing the certificate array"

	^totalBytes! !


!ASN1Value methodsFor: 'testing' stamp: 'PT 1/6/1999 22:16'!
hasIndefiniteLength
	"Answers true if length < 0"

	^length < 0! !

!ASN1Value methodsFor: 'testing' stamp: 'PT 12/11/1998 21:30'!
isConstructed
	"Answers true if encoding is constructed. Answers false if encoding is primitive"

	^constructed! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ASN1Value class
	instanceVariableNames: ''!

!ASN1Value class methodsFor: 'instance creation' stamp: 'PT 12/11/1998 20:44'!
fromByteArray: array startingAt: pos
	"Answers an instance of me created from the specified byte array"

	^self new parse: array startingAt: pos.! !


Object subclass: #X509AlgorithmIdentifier
	instanceVariableNames: 'algorithm oid oidDescription parameters totalBytes '
	classVariableNames: ''
	poolDictionaries: 'ASN1Constants '
	category: 'X509'!
!X509AlgorithmIdentifier commentStamp: '<historical>' prior: 0!
An X.509 Algorithm Identifier!


!X509AlgorithmIdentifier methodsFor: 'private - initialisation' stamp: 'PT 1/10/1999 22:45'!
initialize: anASN1Value
	"Derives the algorithm and its parameters from anASN1Value. Gets the OID for the algorithm"

	| i j ba |
	algorithm := ASN1Value fromByteArray: (anASN1Value data) startingAt: 1. 
	oid := algorithm getOID.
	oidDescription := algorithm getOIDDescription.
	i := algorithm totalBytes + 1.
	(anASN1Value hasIndefiniteLength and: [(anASN1Value data at: i) = 5])
		ifTrue: [j := i + 1]
		ifFalse: [j := anASN1Value data size].
	ba := anASN1Value data copyFrom: i to: j.
	parameters := ASN1Value fromByteArray: ba startingAt: 1.
	totalBytes := (algorithm totalBytes) + (parameters totalBytes) + 2.
	^self! !


!X509AlgorithmIdentifier methodsFor: 'accessing' stamp: 'PT 1/2/1999 18:25'!
getOID
	"Answers the OID for this algorithm"

	^oid! !

!X509AlgorithmIdentifier methodsFor: 'accessing' stamp: 'PT 1/2/1999 18:25'!
getOIDDescription
	"Answers the OID description for this algorithm"

	^oidDescription! !

!X509AlgorithmIdentifier methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:40'!
totalBytes
	"Answers total bytes. See NOTE in totalBytes method of ASN1Value"

	^totalBytes! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509AlgorithmIdentifier class
	instanceVariableNames: ''!

!X509AlgorithmIdentifier class methodsFor: 'instance creation' stamp: 'PT 1/8/1999 13:39'!
fromASN1Value: anASN1Value
	"Answers and instance of me derived from anASN1Value"

	^self new initialize: anASN1Value! !


Object subclass: #X509AttributeValueAssertion
	instanceVariableNames: 'type value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'X509'!
!X509AttributeValueAssertion commentStamp: '<historical>' prior: 0!
An .509 attribute/value assertion pair!


!X509AttributeValueAssertion methodsFor: 'initialisation' stamp: 'PT 1/5/1999 11:37'!
initialize: anASN1Value
	"Performs initialisation"

	type := ASN1Value fromByteArray: anASN1Value data startingAt: 1.
	value := ASN1Value fromByteArray: anASN1Value data startingAt: 1 + type totalBytes.
	^self! !


!X509AttributeValueAssertion methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:08'!
type
	"Answers the type component of the type/value pair"

	^type! !

!X509AttributeValueAssertion methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:09'!
value
	"Answers the value component of the type/value pair"

	^value! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509AttributeValueAssertion class
	instanceVariableNames: ''!

!X509AttributeValueAssertion class methodsFor: 'instance creation' stamp: 'PT 1/8/1999 13:08'!
fromASN1Value: anASN1Value
	"Answers an instance of me derived from anASN1Value"

	^self new initialize: anASN1Value! !


Object subclass: #X509Certificate
	instanceVariableNames: 'encodedCertificate certificateSequence tbsSequence derCertificate tbsCertificate signatureAlgorithm signature '
	classVariableNames: ''
	poolDictionaries: 'ASN1Constants ASN1ObjectIdentifiers '
	category: 'X509'!
!X509Certificate commentStamp: '<historical>' prior: 0!
An X509 V3 certificate as defined by the September 23, 1998 draft of the PKIX Working Group of the Internet Engineering Task Force (IETF) !


!X509Certificate methodsFor: 'private-initialisation' stamp: 'PT 12/15/1998 11:59'!
getCertificateData
	"Answers true if the Base64 encoded certificate has the appropriate delimiters required for PEM format; otherwise, answers false"

	| i j k s |
	i := encodedCertificate indexOfSubCollection: '--BEGIN ' startingAt: 1
		ifAbsent: [^nil].
	i := encodedCertificate indexOfSubCollection: 'CERTIFICATE--' startingAt: i
		ifAbsent: [^nil].
	j := encodedCertificate indexOfSubCollection: '--END ' startingAt: i
		ifAbsent: [^nil].
	k := encodedCertificate indexOfSubCollection: 'CERTIFICATE--' startingAt: j
		ifAbsent: [^nil].
	i := encodedCertificate findAnySubStr: String crlf startingAt: i.
	^(encodedCertificate copyFrom: i to: j)
		reject: [:c | (c = $-) or: [c isSeparator]]! !

!X509Certificate methodsFor: 'private-initialisation' stamp: 'PT 1/10/1999 18:28'!
initialize: aFile
	"Reads the entire contents of the FileStream instantiated from aFile. Checks that it is PEM (i.e. has the appropriate '---BEGIN CERTIFICATE---' and '---END CERTIFICATE---' lines. Strips out all cr/lf characters. Converts from Base 64"

	| fs s |
	fs := FileStream readOnlyFileNamed: aFile.
	encodedCertificate := fs contentsOfEntireFile.
	s := self getCertificateData
		ifNil: [^nil].
	derCertificate := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: s from: 1 to: s size)) contents.
	^self parse! !


!X509Certificate methodsFor: 'private-parsing' stamp: 'PT 2/2/1999 07:22'!
parse
	"Parses the certificate to extract its components and sub-components"

	| ba p b |
	certificateSequence := ASN1Value fromByteArray: derCertificate startingAt: 1.
	certificateSequence hasIndefiniteLength
		ifTrue: [ba := derCertificate copyFrom: 3 to: derCertificate size]
		ifFalse: [ba := certificateSequence data].
	p := 1.
	tbsSequence := ASN1Value fromByteArray: ba startingAt: p.
	tbsCertificate := X509TBSCertificate fromASN1Value: tbsSequence.
	p := p + tbsCertificate totalBytes.
	b := ASN1Value fromByteArray: ba startingAt: p.
	signatureAlgorithm := X509AlgorithmIdentifier fromASN1Value: b.
	p := p + signatureAlgorithm totalBytes.
	ba := ba copyFrom: p to: ba size.
	p := 1.
	[(ba at: p) = 0]
		whileTrue: [p := p + 1].
	signature := ASN1Value fromByteArray: ba startingAt: p.
	^self	! !


!X509Certificate methodsFor: 'accessing' stamp: 'PT 1/2/1999 18:01'!
derCertificate
	"Answers the DER encoded certificate"

	^derCertificate! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 1/2/1999 18:03'!
encodedCertificate
	"Answers the encoded certificate"

	^encodedCertificate! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:43'!
extensions
	"Answers an Ordered Collection of X509Extension objects"

	^tbsCertificate extensions! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/14/1998 18:28'!
issuerDN
	"Answers the distinguished name of the issuer"

	^tbsCertificate issuerDN! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/14/1998 06:41'!
notAfter
	"Answers a string containing notAfter as a UTCTIME"

	^tbsCertificate notAfter! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 1/5/1999 11:52'!
notAfterDate
	"Answers an instance of Date containing the date component of notAfter"

	^tbsCertificate notAfterDate! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/14/1998 06:42'!
notAfterTime
	"Answers an instance of Time containing the time component of notAfter"

	^tbsCertificate notAfterTime! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 1/8/1999 13:44'!
notBefore
	"Answers a string containing notBefore as a UTCTIME"

	^tbsCertificate notAfter! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/14/1998 06:43'!
notBeforeDate
	"Answers an instance of Date containing the date component of notBefore"

	^tbsCertificate notBeforeDate! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/14/1998 06:44'!
notBeforeTime
	"Answers an instance of Time containing the time component of notBefore"

	^tbsCertificate notBeforeTime! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/11/1998 21:03'!
serialNumber
	"Answers the serial number of this certificate"

	^tbsCertificate serialNumber! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 1/2/1999 18:03'!
signature
	"Answers the signature"

	^signature! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/11/1998 22:49'!
signatureAlgorithmOID
	"Answers the OID of the algorithm used to sign this certificate"

	^tbsCertificate signatureAlgorithmOID! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 1/5/1999 11:52'!
signatureAlgorithmOIDDescription
	"Answers the description of the OID of the algorithm used to sign this certificate"

	^tbsCertificate signatureAlgorithmOIDDescription! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/13/1998 20:39'!
subjectDN
	"Answers the distinguished name of the subject"

	^tbsCertificate subjectDN! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/18/1998 21:15'!
subjectPublicKey
	"Answers the subject's public key"

	^tbsCertificate subjectPublicKeyInfo subjectPublicKey! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/15/1998 21:39'!
subjectPublicKeyAlgorithmOID
	"Answers the OID of the algorithm used to generate the subject's public key"

	^tbsCertificate subjectPublicKeyInfo algorithm getOID! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/15/1998 21:40'!
subjectPublicKeyAlgorithmOIDDescription
	"Answers the description of the OID of the algorithm used to generate the subject's public key"

	^tbsCertificate subjectPublicKeyInfo algorithm getOIDDescription! !

!X509Certificate methodsFor: 'accessing' stamp: 'PT 12/11/1998 21:03'!
version
	"Answers the version number of the certificate"

	^tbsCertificate version! !


!X509Certificate methodsFor: 'verifying' stamp: 'PT 1/2/1999 18:54'!
isBeforeValidityDate
	"Answers true if the current date/time is prior to the 'notBefore' date; otherwise, answers false"

	| dt |
	dt := Date dateAndTimeNow.
	^(((dt at: 1) asSeconds) + ((dt at: 2) asSeconds)) <
	((self notBeforeDate) asSeconds + (self notBeforeTime) asSeconds)! !

!X509Certificate methodsFor: 'verifying' stamp: 'PT 1/2/1999 18:56'!
isExpired
	"Answers true if the current data/time is past the 'notAfter' date; otherwise, answers false"

	| dt |
	dt := Date dateAndTimeNow.
	^(((dt at: 1) asSeconds) + ((dt at: 2) asSeconds)) >
	((self notAfterDate) asSeconds + (self notAfterTime) asSeconds)! !

!X509Certificate methodsFor: 'verifying' stamp: 'PT 1/2/1999 19:02'!
isValid
	"Answers true if current date/time is later than the 'notBefore' date and prior to the 'notAfter' date; otherwise, answers false"

	| dt |
	dt := Date dateAndTimeNow.
	^((((dt at: 1) asSeconds) + ((dt at: 2) asSeconds)) <
	((self notBeforeDate) asSeconds + (self notBeforeTime) asSeconds))
	and: [(((dt at: 1) asSeconds) + ((dt at: 2) asSeconds)) >
	((self notAfterDate) asSeconds + (self notAfterTime) asSeconds)]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509Certificate class
	instanceVariableNames: ''!

!X509Certificate class methodsFor: 'instance creation' stamp: 'PT 1/5/1999 11:50'!
fromFile: aFile
	"Answers an instance of me created by parsing the contents of the specified file. If file is not found or if the data in the file cannot be parsed, answers nil"

	^(FileStream isAFileNamed: aFile)
		ifTrue:[self new initialize: aFile]
		ifFalse:[nil]! !


FileList subclass: #X509CertificateBrowser
	instanceVariableNames: 'certificate displayOption lastFileName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'X509'!
!X509CertificateBrowser commentStamp: '<historical>' prior: 0!
A browser used to view raw and formatted X.509 certificates!


!X509CertificateBrowser methodsFor: 'initialisation' stamp: 'PT 12/30/1998 18:37'!
defaultBackgroundColor
	"Answers the default background colour"

	^#veryVeryLightGray! !

!X509CertificateBrowser methodsFor: 'initialisation' stamp: 'PT 1/8/1999 15:05'!
directory: dir
	"Set the path of the volume to be displayed."

	sortMode == nil ifTrue: [sortMode _ #date].
	self okToChange ifFalse: [^ self].
	directory _ dir.
	volList _ ((Array with: '[]'), directory pathParts)  "Nesting suggestion from RvL"
			withIndexCollect: [:each :i | ( String new: i-1 withAll: $ ), each].
	self changed: #volumeList.
	self pattern: pattern! !


!X509CertificateBrowser methodsFor: 'file list' stamp: 'PT 1/8/1999 13:51'!
fileListIndex: anInteger
	"Select the file name having the given index, and display its contents."

	| item name |
	self okToChange ifFalse: [^ self].
	listIndex _ anInteger.
	listIndex = 0 
		ifTrue: [fileName _ nil]
		ifFalse:
			[item _ self fileNameFromFormattedItem: (list at: anInteger).
			(item endsWith: self folderString)
				ifTrue:
					["remove [...] folder string and open the folder"
					name _ item copyFrom: 1 to: item size - self folderString size.
					listIndex _ 0.
					brevityState _ #FileList.
					name first = $^
						ifTrue: [self directory: (ServerDirectory serverNamed: name allButFirst)]
						ifFalse: [self directory: (directory directoryNamed: name)]]
				ifFalse: [fileName _ item]].  "open the file selected"

	brevityState _ #getCertificateFile.
	self changed: #fileListIndex.
	self changed: #contents.! !


!X509CertificateBrowser methodsFor: 'file list menu' stamp: 'PT 12/19/1998 22:37'!
fileContentsMenu: aMenu shifted: shifted

^ shifted 
	ifFalse: [aMenu 
		labels: 
'view certificate file
view formatted certificate
view as hex
find...(f)
find again (g)
set search string (h)
do again (j)
copy (c)
print it (p)'
		lines: #(3 7 8)
		selections: #(viewFile viewFormatted viewHex find findAgain setSearchString again undo copySelection printIt)]
! !

!X509CertificateBrowser methodsFor: 'file list menu' stamp: 'PT 1/8/1999 13:53'!
itemsForAnyFile
	"Menu items for any file"

	^#(('copy name to clipboard')()(copyName))! !

!X509CertificateBrowser methodsFor: 'file list menu' stamp: 'PT 12/30/1998 18:26'!
itemsForFileEnding: suffix
	| labels lines selectors |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selectors _ OrderedCollection new.
	(suffix = 'pem') | (suffix = 'cert') | (suffix = '*') ifTrue:
		[labels addAll: #().
		selectors addAll: #()].
	^ Array with: labels with: lines with: selectors! !

!X509CertificateBrowser methodsFor: 'file list menu' stamp: 'PT 1/5/1999 11:54'!
itemsForNoFile

	^ #(
		('sort by name' 'sort by size' 'sort by date')
		()
		(sortByName sortBySize sortByDate))! !


!X509CertificateBrowser methodsFor: 'private' stamp: 'PT 1/8/1999 13:58'!
contents
	"Answer the contents of the file"

	| s |
	(listIndex = 0) | (brevityState == #FileList) ifTrue: [^ self defaultContents].  "no file selected"
	brevityState == #getCertificateFile
		ifTrue: [^self getCertificateFile].
	brevityState == #getCertificateAndFormat
		ifTrue: [^self getFormattedCertificate].
	brevityState == #getCertificateHex
		ifTrue: [^self getHex].
	certificate := X509Certificate fromFile: self fullName.
	s := WriteStream on: String new.
	certificate encodedCertificate do: [:c |
		(c = Character cr) | (c = Character lf)
			ifTrue: [s cr]
			ifFalse: [s nextPutAll:  c asString]
		].
	contents :=  s contents.
	^contents! !

!X509CertificateBrowser methodsFor: 'private' stamp: 'PT 1/5/1999 12:33'!
getCertificateFile
	"Answers the contents of the currently selected file"

	| s crf |
	certificate := X509Certificate fromFile: self fullName.
	s := WriteStream on: String new.
	crf := false.
	certificate encodedCertificate do: [:c |
		(c = Character cr) | (c = Character lf)
			ifTrue: [
				crf
					ifTrue: [crf := false]
					ifFalse: [s cr. crf := true].
			]
			ifFalse: [s nextPutAll:  c asString. crf := false]
		].
	^contents :=  s contents.! !

!X509CertificateBrowser methodsFor: 'private' stamp: 'PT 1/13/1999 21:12'!
getFormattedCertificate
	"Answers a String containing the formatted certificate"

	| s idn i pk |
	certificate := X509Certificate fromFile: self fullName.
	s := WriteStream on: String new.

	s nextPutAll: 'X509 Certificate Version: ';
		nextPutAll: certificate version asString;
		nextPutAll: ' Serial Number: ';
		nextPutAll: certificate serialNumber asString.

	idn := certificate issuerDN.

	s cr;cr;
		nextPutAll: 'Issuer: '.
	idn := certificate issuerDN.
	i := 1.
	idn size timesRepeat: [
		s
			nextPutAll: ((idn at: i) type getOIDDescription);
			nextPutAll: '=';
			nextPutAll: ((idn at: i) value getString).
		(i  = (idn size))
			ifFalse: [s nextPutAll: ', '].
		i := i + 1.
	].

	s cr;cr;
		nextPutAll: 'Not valid before: ';
		nextPutAll: certificate notBeforeDate asString;
		nextPutAll: ' ';
		nextPutAll: certificate notBeforeTime asString;
		cr;
		nextPutAll: 'Not valid after: ';
		nextPutAll: certificate notAfterDate asString;
		nextPutAll: ' ';
		nextPutAll: certificate notAfterTime asString.

	idn := certificate issuerDN.

	s cr;cr;
		nextPutAll: 'Subject: '.
	idn := certificate subjectDN.
	i := 1.
	idn size timesRepeat: [
		s
			nextPutAll: ((idn at: i) type getOIDDescription);
			nextPutAll: '=';
			nextPutAll: ((idn at: i) value getString).
		(i = (idn size))
			ifFalse: [s nextPutAll: ', '].
		i := i + 1.
	].

	s cr;cr;
		nextPutAll: 'Subject Public Key Algorithm: ';
		nextPutAll: certificate subjectPublicKeyAlgorithmOID;
		nextPutAll: ' (';
		nextPutAll: certificate subjectPublicKeyAlgorithmOIDDescription;
		nextPutAll: ')'.

	s cr;cr;
		nextPutAll: 'Public Key:'.
	pk := certificate subjectPublicKey getBitStringAsFormattedHexStrings.
	pk do: [:b |  s crtab; nextPutAll: b asString.
	].

	certificate extensions isNil
		ifFalse: [
			s cr;cr;nextPutAll: 'EXTENSIONS:'.
			certificate extensions do: [: ext |
				s crtab;nextPutAll: ext id;
					nextPutAll: ' (';
					nextPutAll: ext idDescription;
					nextPutAll: ')'.
					ext isCritical
						ifTrue: [s tab;nextPutAll: 'CRITICAL'].
			]
		].

	s cr;cr;
		nextPutAll: 'Signature Algorithm: ';
		nextPutAll: certificate signatureAlgorithmOID;
		nextPutAll: ' (';
		nextPutAll: certificate signatureAlgorithmOIDDescription;
		nextPutAll: ')'.

	s cr;cr;
		nextPutAll: 'Signature:'.
	pk := certificate signature getBitStringAsFormattedHexStrings.
	pk do: [:b |  s crtab; nextPutAll: b asString.
	].

	^contents := s contents! !

!X509CertificateBrowser methodsFor: 'private' stamp: 'PT 1/5/1999 11:58'!
getHex
	"Answers the hexadecimal representation of the certificate"

	| s data |
	certificate := X509Certificate fromFile: self fullName.
	data := certificate derCertificate.
	s _ WriteStream on: (String new:  data size*4).
	0 to: data size-1 by: 16 do:
		[:loc | s nextPutAll: loc hex; space;
			nextPut: $(; print: loc; nextPut: $); space; tab.
		loc+1 to: (loc+16 min: data size) do: [:i | s nextPutAll: (data at: i) hex; space].
		s cr].
	^contents := s contents
! !

!X509CertificateBrowser methodsFor: 'private' stamp: 'PT 1/5/1999 12:01'!
viewFile
	"Invoked in response to selection of 'View File' from menu"

	brevityState := #getCertificateFile.
	self changed: #contents! !

!X509CertificateBrowser methodsFor: 'private' stamp: 'PT 1/8/1999 13:59'!
viewFormatted
	"Invoked in response to selection of 'View Formatted' from menu"

	brevityState := #getCertificateAndFormat.
	self changed: #contents! !

!X509CertificateBrowser methodsFor: 'private' stamp: 'PT 1/5/1999 12:06'!
viewHex
	"Invoked in response to selection of 'View Hex' from menu"

	brevityState := #getCertificateHex.
	self changed: #contents! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509CertificateBrowser class
	instanceVariableNames: ''!

!X509CertificateBrowser class methodsFor: 'instance creation' stamp: 'PT 1/8/1999 13:50'!
open
	"Open a view of an instance of me on the default directory."
	"X509CertificateBrowser open"
	| dir aFileList topView volListView fileListView fileContentsView |

	dir _ FileDirectory default.
	aFileList _ self new directory: dir.
	topView _ StandardSystemView new.
	topView
		model: aFileList;
		label: 'X509 Certificate Browser';
		minimumSize: 200@500.
	topView borderWidth: 1.

	volListView _ PluggableListView on: aFileList
		list: #volumeList
		selected: #volumeListIndex
		changeSelected: #volumeListIndex:
		menu: #volumeMenu:.
	volListView autoDeselect: false.
	volListView window: (0@0 extent: 80@40).
	topView addSubView: volListView.

	fileListView _ PluggableListView on: aFileList
		list: #fileList
		selected: #fileListIndex
		changeSelected: #fileListIndex:
		menu: #fileListMenu:.
	fileListView window: (0@0 extent: 120@40).
	topView addSubView: fileListView toRightOf: volListView.
	fileListView controller terminateDuringSelect: true.  "Pane to left may change under scrollbar"

	fileContentsView _ PluggableTextView on: aFileList
		text: #contents accept: #put:
		readSelection: #contentsSelection menu: #fileContentsMenu:shifted:.
	fileContentsView window: (0@0 extent: 200@140).
	topView addSubView: fileContentsView below: volListView.

	topView controller open.
! !


Object subclass: #X509Extension
	instanceVariableNames: 'id idDescription critical value '
	classVariableNames: ''
	poolDictionaries: 'ASN1Constants '
	category: 'X509'!
!X509Extension commentStamp: '<historical>' prior: 0!
An X.509 Certificate Extension!


!X509Extension methodsFor: 'private - initialisation' stamp: 'PT 1/9/1999 20:41'!
initialize: anASN1Value
	"Performs initialisation"

	| d p obj |
	d := anASN1Value data.
	p := 1.
	obj := ASN1Value fromByteArray: d startingAt: p.
	(obj tag = idObjectIdentifier)
		ifFalse: [self error: 'expecting OID'].
	id := obj getOID.
	idDescription := obj getOIDDescription.
	p := p + obj totalBytes.
	obj := ASN1Value fromByteArray: d startingAt: p.
	critical := obj tag = idBoolean.
	critical
		ifTrue: [p := p + obj totalBytes.
			obj := ASN1Value fromByteArray: d startingAt: p.
			].
	value := obj! !


!X509Extension methodsFor: 'accessing' stamp: 'PT 1/4/1999 13:10'!
id
	"Answers the OID for the extension"

	^id! !

!X509Extension methodsFor: 'accessing' stamp: 'PT 1/5/1999 11:38'!
idDescription
	"Answers the description of the OID for the extension"

	^idDescription! !

!X509Extension methodsFor: 'accessing' stamp: 'PT 1/4/1999 13:11'!
isCritical
	"Answers the value of the instance variable critical"

	^critical! !

!X509Extension methodsFor: 'accessing' stamp: 'PT 1/4/1999 13:11'!
value
	"Answers the value"

	^value! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509Extension class
	instanceVariableNames: ''!

!X509Extension class methodsFor: 'instance creation' stamp: 'PT 1/5/1999 11:37'!
fromASN1Value: anASN1Value
	"Answers an instance of me from anASN1Value"

	^ self new initialize: anASN1Value
	! !


Object subclass: #X509Name
	instanceVariableNames: 'relativeDistinguishedName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'X509'!
!X509Name commentStamp: '<historical>' prior: 0!
An X.509 Distinguished Name!


!X509Name methodsFor: 'private - initialisation' stamp: 'PT 1/8/1999 13:18'!
initialize: anASN1Value
	"Performs initialisation"

	| seql setobj seqobj i |
	seql := anASN1Value length.
	i := 1.
	relativeDistinguishedName := OrderedCollection new.
	[seql > 0] whileTrue: [
		setobj := ASN1Value fromByteArray: anASN1Value data startingAt: i.
		seqobj := ASN1Value fromByteArray: setobj data startingAt: 1.
		relativeDistinguishedName addLast:
			(X509AttributeValueAssertion fromASN1Value: seqobj).
		seql := seql - setobj totalBytes.
		i := i + setobj totalBytes.
	].
	^self! !


!X509Name methodsFor: 'accessing' stamp: 'PT 12/13/1998 20:34'!
getRDN
	"Answers an OrderedCollection containing the RDN attribute/value pairs"

	^relativeDistinguishedName! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509Name class
	instanceVariableNames: ''!

!X509Name class methodsFor: 'instance creation' stamp: 'PT 1/5/1999 11:39'!
fromASN1Value: anASN1Value
	"Answers an instance of me from anASN1Value"

	^ self new initialize: anASN1Value
	! !


Object subclass: #X509SubjectPublicKeyInfo
	instanceVariableNames: 'algorithm subjectPublicKey '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'X509'!
!X509SubjectPublicKeyInfo commentStamp: '<historical>' prior: 0!
X.509 SubjectPublicKeyInfo!


!X509SubjectPublicKeyInfo methodsFor: 'private - initialisation' stamp: 'PT 1/8/1999 13:19'!
initialize: anASN1Value
	"Performs initialisation"

	| b |
	b := ASN1Value fromByteArray: (anASN1Value data) startingAt: 1.
	algorithm := X509AlgorithmIdentifier fromASN1Value: b.
	subjectPublicKey := ASN1Value fromByteArray: (anASN1Value data)
		startingAt: (1 + b totalBytes).
	^self! !


!X509SubjectPublicKeyInfo methodsFor: 'accessing' stamp: 'PT 12/15/1998 21:32'!
algorithm
	"Answers the algorithm used to sign the public key"

	^algorithm! !

!X509SubjectPublicKeyInfo methodsFor: 'accessing' stamp: 'PT 12/18/1998 21:53'!
subjectPublicKey
	"Answers the subject's public key"

	^subjectPublicKey! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509SubjectPublicKeyInfo class
	instanceVariableNames: ''!

!X509SubjectPublicKeyInfo class methodsFor: 'instance creation' stamp: 'PT 1/8/1999 14:02'!
fromASN1Value: anASN1Value
	"Answers an instance of me derived from anASN1Value"

	^self new initialize: anASN1Value! !


Object subclass: #X509TBSCertificate
	instanceVariableNames: 'tbsSequence version serialNumber signature issuer validity subject subjectPublicKeyInfo extensions totalBytes '
	classVariableNames: ''
	poolDictionaries: 'ASN1Constants '
	category: 'X509'!
!X509TBSCertificate commentStamp: '<historical>' prior: 0!
A TBS (to be signed) certificate!


!X509TBSCertificate methodsFor: 'private - parsing' stamp: 'PT 1/8/1999 14:04'!
getExtensions: anASN1Value
	"Extracts an OrderedCollection of X509Extension objects from anASN1Value"

	| p obj |
	(anASN1Value tag = idSequence)
		ifFalse: [^nil].
	extensions := OrderedCollection new.
	p := 1.
	[p < anASN1Value data size] whileTrue: [
		obj := ASN1Value fromByteArray: (anASN1Value data) startingAt: p.
		extensions addLast: (X509Extension fromASN1Value: obj).
		p := p + obj totalBytes.
		]! !

!X509TBSCertificate methodsFor: 'private - parsing' stamp: 'PT 2/2/1999 07:18'!
parse: anASN1Value
	"Parses anASN1Value into the appropriate certificate components"

	| b p oc |
	tbsSequence := anASN1Value.
	totalBytes := tbsSequence totalBytes.
	p := 1.
	b := ASN1Value fromByteArray: tbsSequence data startingAt: 1.
	(((b getClass = (ASN1Constants at: #classContextSpecific)) 
		and: [b isConstructed]) and: [b tag = 0])
		ifTrue: [p := p + b totalBytes.
			b := ASN1Value fromByteArray: b data startingAt: 1.
			version := b getInteger + 1.
			b := ASN1Value fromByteArray: tbsSequence data startingAt: p]
		 ifFalse: [version := 1].
	serialNumber := b getInteger.
	oc := OrderedCollection new.
	p := b totalBytes + p.
	[p > tbsSequence length] whileFalse: [(tbsSequence data at: p) = 0 ifTrue:[self halt].
		b := ASN1Value fromByteArray: tbsSequence data startingAt: p.
		p := b totalBytes + p.
		oc addLast: b.
		].
	signature := X509AlgorithmIdentifier fromASN1Value: (oc at: 1).
	issuer := X509Name fromASN1Value: (oc at: 2).
	validity := X509Validity fromASN1Value: (oc at: 3).
	subject := X509Name fromASN1Value: (oc at: 4).
	subjectPublicKeyInfo := X509SubjectPublicKeyInfo fromASN1Value: (oc at: 5).
	oc size > 5
		ifFalse: [^self].
	6 to: (oc size) do: [:i |
		b := oc at: i.
		((b getClass = classContextSpecific) and: [(b tag = 3)])
			ifTrue: [self getExtensions: (ASN1Value fromByteArray: (b data) startingAt: 1)].
	].
	^self
! !


!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 1/8/1999 14:05'!
extensions
	"Answers an Ordered Collection of X509Extension objects"

	^extensions! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/14/1998 18:29'!
issuerDN
	"Answers the distinguished name of the issuer"

	^issuer getRDN! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/14/1998 06:52'!
notAfter
	"Answers an instance of String containing notAfter as a UTCTIME"

	^validity notAfter! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/14/1998 06:49'!
notAfterDate
	"Answers an instance of Date containing the date component of notAfter"

	^validity notAfterDate! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/14/1998 06:50'!
notAfterTime
	"Answers an instance of Time containing the time component of notAfter"

	^validity notAfterTime! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 1/5/1999 11:49'!
notBefore
	"Answers an instance of String containing notBefore as a UTCTIME"

	^validity notBefore! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/14/1998 06:53'!
notBeforeDate
	"Answers an instance of Date containing the date component of notBefore"

	^validity notBeforeDate! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/14/1998 06:53'!
notBeforeTime
	"Answers an instance of Time containing the time component of notBefore"

	^validity notBeforeTime! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/11/1998 22:35'!
serialNumber
	"Answers the serial number of this certificate"

	^serialNumber
	! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/14/1998 06:54'!
signatureAlgorithmOID
	"Answers the OID of the algorithm used to sign this certificate"

	^signature getOID! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 1/5/1999 11:50'!
signatureAlgorithmOIDDescription
	"Answers the description of the OID of the algorithm used to sign this certificate"

	^signature getOIDDescription! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/14/1998 06:54'!
subjectDN
	"Answers the distinguished name of the subject"

	^subject getRDN! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/15/1998 21:31'!
subjectPublicKeyInfo
	"Answers the subject's public key info"

	^subjectPublicKeyInfo! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 1/2/1999 18:12'!
totalBytes
	"Answers the total number of bytes in the TBS"

	^totalBytes! !

!X509TBSCertificate methodsFor: 'private - accessing' stamp: 'PT 12/11/1998 21:53'!
version
	"Answers the version of this certificate"

	^version
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509TBSCertificate class
	instanceVariableNames: ''!

!X509TBSCertificate class methodsFor: 'instance creation' stamp: 'PT 1/29/1999 05:53'!
fromASN1Value: anASN1Value
	"Answer an instance of me derived from anASN1Value"


	^self new parse: anASN1Value
! !


Object subclass: #X509Validity
	instanceVariableNames: 'notBefore notAfter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'X509'!
!X509Validity commentStamp: '<historical>' prior: 0!
An X.509 Validity object!


!X509Validity methodsFor: 'private - initialisation' stamp: 'PT 1/2/1999 18:14'!
initialize: anASN1Value
	"Extracts 'notBefore' and 'notAfter' "

	notBefore := ASN1Value fromByteArray: (anASN1Value data) startingAt: 1.
	notAfter := ASN1Value fromByteArray: (anASN1Value data)
		startingAt: (1 + (notBefore totalBytes)).
	^self! !


!X509Validity methodsFor: 'accessing' stamp: 'PT 12/13/1998 21:24'!
notAfter
	"Answers a string containing the notAfter date/time as a UTCTime"

	^notAfter getString! !

!X509Validity methodsFor: 'accessing' stamp: 'PT 12/13/1998 22:10'!
notAfterDate
	"Answers the date component of notAfter"

	| s y |
	s := notAfter getString.
	y := s copyFrom: 1 to: 2.
	(y asNumber > 50)
		ifTrue: [y := '19' , y]
		ifFalse: [y := '20' , y].
	^Date fromString: (s copyFrom: 5 to: 6) , '.' , (s copyFrom: 3 to: 4) , '.' , y! !

!X509Validity methodsFor: 'accessing' stamp: 'PT 12/13/1998 22:21'!
notAfterTime
	"Answers the time component of notAfter"

	| s |
	s := notAfter getString.
	s := (s copyFrom: 7 to: 8) , ':' , (s copyFrom: 9 to: 10) , ':' , (s copyFrom: 11 to: 12).
	^Time readFrom: (ReadStream on: s from: 1 to: s size)! !

!X509Validity methodsFor: 'accessing' stamp: 'PT 12/13/1998 21:23'!
notBefore
	"Answers a string containing the notBefore date/time as a UTCTime"

	^notBefore getString! !

!X509Validity methodsFor: 'accessing' stamp: 'PT 12/13/1998 22:24'!
notBeforeDate
	"Answers the date component of notBefore"

	| s y |
	s := notBefore getString.
	y := s copyFrom: 1 to: 2.
	(y asNumber > 50)
		ifTrue: [y := '19' , y]
		ifFalse: [y := '20' , y].
	^Date fromString: (s copyFrom: 5 to: 6) , '.' , (s copyFrom: 3 to: 4) , '.' , y! !

!X509Validity methodsFor: 'accessing' stamp: 'PT 12/13/1998 22:25'!
notBeforeTime
	"Answers the time component of notBefore"

	| s |
	s := notBefore getString.
	s := (s copyFrom: 7 to: 8) , ':' , (s copyFrom: 9 to: 10) , ':' , (s copyFrom: 11 to: 12).
	^Time readFrom: (ReadStream on: s from: 1 to: s size)! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

X509Validity class
	instanceVariableNames: ''!

!X509Validity class methodsFor: 'instance creation' stamp: 'PT 1/2/1999 18:13'!
fromASN1Value: anASN1Value
	"Answers an instance of me from anASN1Value"

	^self new initialize: anASN1Value! !
