package com.beechwood.certificates;

public class X509AlgorithmIdentifier {
  ASN1Value algorithm;
  String oid;
  String oidDescription;
  ASN1Value parameters;
  int totalBytes;

  public X509AlgorithmIdentifier(ASN1Value obj) 
      throws X509CertificateException {
    algorithm = new ASN1Value(obj.data, 0);
    try {
      oid = algorithm.getOID();
    }
    catch (ASN1ValueException e) {
      throw new X509CertificateException(e.getMessage());
    }
    oidDescription = algorithm.getOIDDescription();
    int i = algorithm.totalBytes();
    int db = obj.data[i] & 0xff;
    int j;
    if ((obj.hasIndefiniteLength()) && (db == 5)) {
      j = i + 1;
    }
    else {
      j = obj.data().length - 1;
    }
    byte[] ba = new byte[j - i + 1];
    System.arraycopy(obj.data(),i,ba,0,j - i + 1);
    parameters = new ASN1Value(ba,0);
    totalBytes = algorithm.totalBytes() + parameters.totalBytes();
  }

  public String getOID() {
    return oid;
  }

  public String getOIDDescription() {
    return oidDescription;
  }

  public int totalBytes() {
    return totalBytes;
  }
}
