package com.beechwood.certificates;

public class X509Extension {
  String id;
  String idDescription;
  boolean critical = false;
  ASN1Value value;

  X509Extension(ASN1Value asn1Value) 
      throws X509CertificateException {
    byte[] d = asn1Value.data();
    int p = 0;
    ASN1Value obj = new ASN1Value(d,p);
    if (obj.tag() != 6)
      return;
    try {
      id = obj.getOID();
    }
    catch (ASN1ValueException e) {
      throw new X509CertificateException(e.getMessage());
    }
    idDescription = obj.getOIDDescription();
    p = p + obj.totalBytes();
    obj = new ASN1Value(d,p);
    if (obj.tag() == 1) {
      critical = true;
      obj = new ASN1Value(d,p);
    }
    value = obj;
  }

  public String id() {
    return id;
  }

  public String idDescription() {
    return idDescription;
  }

  public boolean isCritical() {
    return critical;
  }

  public ASN1Value value() {
    return value;
  }
}
