package com.beechwood.certificates;

import java.util.Enumeration;
import java.util.Vector;

public class X509Name {
  Vector rdn;

  X509Name(ASN1Value asn1Value) {
    rdn = new Vector();
    int seql = asn1Value.length();
    int i = 0;
    while (seql > 0) {
      ASN1Value setobj = new ASN1Value(asn1Value.data(),i);
      ASN1Value seqobj = new ASN1Value(setobj.data(),0);
      rdn.addElement (new X509AttributeValueAssertion(seqobj));
      seql = seql - setobj.totalBytes();
      i = i + setobj.totalBytes();
    }
  }

  public String getRDN() throws X509CertificateException {
    StringBuffer sb = new StringBuffer();
    for (Enumeration enum = rdn.elements(); enum.hasMoreElements();) {
      X509AttributeValueAssertion ava =
        (X509AttributeValueAssertion)(enum.nextElement());
      sb.append(ava.type().getOIDDescription());
      sb.append("=");
      sb.append(ava.value().getString());
      sb.append(", ");
    }
    sb.setLength(sb.length() - 2);
    return sb.toString();
  }
}
